

/*
This is a UI file (.ui.qml) that is intended to be edited in Qt Design Studio only.
It is supposed to be strictly declarative and only uses a subset of QML. If you edit
this file manually, you might introduce QML code that is not supported by Qt Design Studio.
Check out https://doc.qt.io/qtcreator/creator-quick-ui-forms.html for details on .ui.qml files.
*/
import QtQuick 6.2
import QtQuick.Controls 6.2
import AnimationsTimeline
import QtQuick.Timeline 1.0

Rectangle {
    width: Constants.width
    height: Constants.height

    color: Constants.backgroundColor

    Rectangle {
        id: bleu
        x: 40
        y: 35
        width: 14
        height: 120
        color: "#092cf4"
    }

    Rectangle {
        id: rouge
        x: 591
        y: 305
        width: 14
        height: 120
        color: "#f3290b"
    }

    Timeline {
        id: timelineBalle
        animations: [
            TimelineAnimation {
                id: balleAnimation
                running: true
                duration: 1000
                loops: 1
                to: 1000
                from: 0
            }
        ]
        enabled: true
        startFrame: 0
        endFrame: 10000

        KeyframeGroup {
            target: bleu
            property: "y"
            Keyframe {
                frame: 7
                value: 35
            }

            Keyframe {
                frame: 901
                value: 350
            }
        }

        KeyframeGroup {
            target: balle
            property: "x"
            Keyframe {
                frame: 0
                value: 565
            }

            Keyframe {
                frame: 901
                value: 55
            }

            Keyframe {
                frame: 1793
                value: 485
            }
        }

        KeyframeGroup {
            target: rouge
            property: "y"
            Keyframe {
                frame: 1795
                value: 30
            }

            Keyframe {
                frame: 903
                value: 305
            }
        }

        KeyframeGroup {
            target: balle
            property: "y"

            Keyframe {
                frame: 901
                value: 368
            }

            Keyframe {
                frame: 1790
                value: 38.12
            }
        }
    }

    Rectangle {
        id: balle
        x: 565
        y: 378
        width: 20
        height: 20
        color: "#ffffff"
        radius: 10
    }
}
