#ifndef EMPLOYE_H
#define EMPLOYE_H

#include <QString>
#include <QSharedData>
#include <QQuickItem>
#include <QDebug>

class EmployeData : public QSharedData
{
public:
    EmployeData() {}

    int matricule_ = 0;
    QString nom_;
    QString prenom_;
    QString adresse_;
    QString codePostal_;
    QString ville_;
};

class Employe : public QQuickItem
{
    Q_OBJECT
    Q_PROPERTY(int matricule READ matricule WRITE setMatricule NOTIFY matriculeChanged)
    Q_PROPERTY(QString nom READ nom WRITE setNom NOTIFY nomChanged)
    Q_PROPERTY(QString prenom READ prenom WRITE setPrenom NOTIFY prenomChanged)
    Q_PROPERTY(QString adresse READ adresse WRITE setAdresse NOTIFY adresseChanged)
    Q_PROPERTY(QString codePostal READ codePostal WRITE setCodePostal NOTIFY codePostalChanged)
    Q_PROPERTY(QString ville READ ville WRITE setVille NOTIFY villeChanged)

signals:
    void matriculeChanged();
    void nomChanged();
    void prenomChanged();
    void adresseChanged();
    void codePostalChanged();
    void villeChanged();

public:
    Employe() : d_(new EmployeData) { qDebug() << "construction" << &d_; }
    Employe(const Employe& orig) : d_(orig.d_) {}
    Employe& operator=(const Employe& orig) {
        d_ = orig.d_;
        return *this;
    }
    virtual ~Employe() { qDebug() << "destruction" << &d_ << "(" << d_->nom_ << ")";  }

    int matricule() const { return d_->matricule_; }
    void setMatricule(const int& matricule) { d_->matricule_ = matricule; emit matriculeChanged(); }
    QString nom() const { return d_->nom_; }
    void setNom(const QString& nom) { d_->nom_ = nom; emit nomChanged(); }
    QString prenom() const { return d_->prenom_; }
    void setPrenom(const QString& prenom) { d_->prenom_ = prenom; emit prenomChanged(); }
    QString adresse() const { return d_->adresse_; }
    void setAdresse(const QString& adresse) { d_->adresse_ = adresse; emit adresseChanged(); }
    QString codePostal() const { return d_->codePostal_; }
    void setCodePostal(const QString& codePostal) { d_->codePostal_ = codePostal; emit codePostalChanged(); }
    QString ville() const { return d_->ville_; }
    void setVille(const QString& ville) { d_->ville_ = ville; emit villeChanged(); }

private:
    QSharedDataPointer<EmployeData> d_;
};

#endif // EMPLOYE_H
