#ifndef EMPLOYE_H
#define EMPLOYE_H

#include <QString>
#include <QSharedData>
#include <QQuickItem>
#include <QDebug>
#include "TEmploye.h"

class EmployeData : public QSharedData
{
public:
    EmployeData() :
        employe_(new TEmploye(-1, "", "")) {}

    TEmploye *employe_;
};

class Employe : public QQuickItem
{
    Q_OBJECT
    Q_PROPERTY(int matricule READ matricule WRITE setMatricule NOTIFY matriculeChanged)
    Q_PROPERTY(QString nom READ nom WRITE setNom NOTIFY nomChanged)
    Q_PROPERTY(QString prenom READ prenom WRITE setPrenom NOTIFY prenomChanged)

signals:
    void matriculeChanged();
    void nomChanged();
    void prenomChanged();

public:
    Employe() : d_(new EmployeData) { /*qDebug() << "construction" << &d_;*/ }
    Employe(const Employe& orig) : d_(orig.d_) {}
    Employe& operator=(const Employe& orig) {
        d_ = orig.d_;
        return *this;
    }
    virtual ~Employe() { /*qDebug() << "destruction" << &d_ << "(" << d_->employe_->nom() << ")";*/ }

    int matricule() const { return d_->employe_->matricule(); }
    void setMatricule(const int& matricule) { d_->employe_->setMatricule(matricule); }
    QString nom() const { return QString::fromUtf8(d_->employe_->nom()); }
    void setNom(const QString& nom) { d_->employe_->setNom(nom.toUtf8()); }
    QString prenom() const { return QString::fromUtf8(d_->employe_->prenom()); }
    void setPrenom(const QString& prenom) { d_->employe_->setPrenom(prenom.toUtf8()); }

private:
    QSharedDataPointer<EmployeData> d_;
};

#endif // EMPLOYE_H
