import QtQuick 6.2
import QtQuick.Controls 6.2
import QtMultimedia

Rectangle {
    id: rectangle
    width: Constants.width
    height: Constants.height

    color: Constants.backgroundColor    

    ComboBox {
        id: comboBox
        anchors.left: parent.left
        anchors.top: parent.top
        anchors.topMargin: 0
        anchors.horizontalCenter: parent.horizontalCenter
        anchors.leftMargin: 0

        model: ListModel {
          id: listeVideos
          ListElement {
            text: ""
            internalId: -1
          }
          ListElement {
            text: "Webcam locale"
            internalId: 0
          }
        }
        textRole: 'text'
    }

    Button {
        id: btnLecture
        text: qsTr("Lire")
        anchors.left: parent.left
        anchors.top: comboBox.bottom
        anchors.topMargin: 20
        anchors.leftMargin: 76
    }

    Button {
        id: btnStop
        x: 407
        text: qsTr("Stopper")
        anchors.right: parent.right
        anchors.top: comboBox.bottom
        anchors.topMargin: 10
        anchors.rightMargin: 76
    }

    Rectangle {
        color: "black"
        anchors.right: parent.right
        anchors.left: parent.left
        anchors.bottom: parent.bottom
        anchors.top: btnLecture.bottom
        anchors.topMargin: 20

        VideoOutput {
            id: videoOutput
            visible: false
            anchors.fill: parent
        }
    }
}
