/*
This is a UI file (.ui.qml) that is intended to be edited in Qt Design Studio only.
It is supposed to be strictly declarative and only uses a subset of QML. If you edit
this file manually, you might introduce QML code that is not supported by Qt Design Studio.
Check out https://doc.qt.io/qtcreator/creator-quick-ui-forms.html for details on .ui.qml files.
*/

import QtQuick 6.2
import QtQuick.Controls 6.2
//import QtDesignStudio2
import QtMultimedia

Rectangle {
    id: rectangle
    width: 800
    height: 600

    color: "white"
    border.color: "#ffffff"
    property alias comboBox:  comboBox
    property alias btnLecture:  btnLecture
    property alias btnStop:  btnStop
    property alias videoOutput:  videoOutput
    property alias listeVideos: listeVideos
    //property alias mediaDevices: mediaDevices
    property alias mediaPlayer:  mediaPlayer
    //property alias camera:  camera

    ComboBox {
        id: comboBox
        anchors.left: parent.left
        anchors.top: parent.top
        anchors.topMargin: 0
        anchors.horizontalCenter: parent.horizontalCenter
        anchors.leftMargin: 0

        model: ListModel {
          id: listeVideos
          ListElement {
            text: ""
            internalId: -1
          }          
        }
        textRole: 'text'
    }    

    Button {
        id: btnLecture
        text: qsTr("Lire")
        anchors.left: parent.left
        anchors.top: comboBox.bottom
        anchors.topMargin: 20
        anchors.leftMargin: 76
    }

    Button {
        id: btnStop
        x: 407
        text: qsTr("Stopper")
        anchors.right: parent.right
        anchors.top: comboBox.bottom
        anchors.topMargin: 10
        anchors.rightMargin: 76
    }

    Rectangle {
        color: "black"
        anchors.right: parent.right
        anchors.left: parent.left
        anchors.bottom: parent.bottom
        anchors.top: btnLecture.bottom
        anchors.topMargin: 20

        VideoOutput {
            id: videoOutput
            visible: true
            anchors.fill: parent
        }
    }

    MediaPlayer {
      id: mediaPlayer
      videoOutput: videoOutput
    }
}

