import QtQuick
import QtMultimedia

Screen01 {
    property var urls: new Array()

    comboBox.onCurrentIndexChanged: {
       //Récupération de l’index dans la liste déroulante
       var index = comboBox.currentIndex
       //Récupération de l’identifiant interne dans le modèle
       var idVideo = listeVideos.get(index).internalId
       //Récupération du libellé dans le modèle
       var nomVideo = listeVideos.get(index).text

       if(idVideo !== -1) {
          console.log("Vidéo sélectionnée : " + nomVideo +" (" +idVideo +")")
          //Nous autorisons la lecture
          btnLecture.enabled = true
       } else {
          btnLecture.enabled = false
       }
    }

    Component.onCompleted: {
        listeVideos.append({ text: "Vidéo 1", internalId: 0})
        listeVideos.append({ text: "Vidéo 2", internalId: 1})
        listeVideos.append({ text: "Vidéo locale", internalId: 2})

        //Préparation de la liste des vidéos
        urls.push("https://file-examples.com/wp-content/uploads/2018/04/file_example_AVI_480_750kB.avi")
        urls.push("http://www.sample-videos.com/video/mp4/360/big_buck_bunny_360p_10mb.mp4")
        urls.push("file:///Users/tristan/Download/file_example_MP4_480_1_5MG.mp4")
    }

    btnLecture.onClicked: {
        console.log("Lecture vidéo demandée...")
        var index = comboBox.currentIndex
        var idVideo = listeVideos.get(index).internalId

        //Nous vérifions qu’une ligne non vide à bien été sélectionnée
        if(idVideo !== -1) {
            //Nous récupérons l’URL de la vidéo dans notre tableau
            var url = urls[idVideo]
            console.log("URL de la vidéo : " +url)

             //Définition de la source pour le lecteur de vidéo
             mediaPlayer.source = url
             //Lancement de la lecture de la vidéo
             mediaPlayer.play()
            videoOutput.visible = true
        } else {
            console.error("Aucune vidéo sélectionnée");
        }
    }

    btnStop.onClicked: {
       mediaPlayer.stop()
    }
}
