#include <QApplication>
#include <QtSensors>

int main(int argc, char *argv[])
{
    QCoreApplication a(argc, argv);

    foreach (const QByteArray &type, QSensor::sensorTypes()) {
        qDebug() << "Trouvé un capteur du type" << type;
        foreach (const QByteArray &identifier, QSensor::sensorsForType(type)) {
            qDebug() << "Trouvé l'identifiant" << identifier;
            // On n'ajoute pas les capteurs qu'on ne peut pas utiliser
            QSensor* sensor = new QSensor(type, &a);
            sensor->setIdentifier(identifier);
            if (!sensor->connectToBackend()) {
                qDebug() << "Impossible de se connecter à" << identifier;
                continue;
            }

            qDebug() << "Ajout de l'identifiant" << identifier;
        }
    }

    return a.exec();
}
