import QtQuick 6.2
import QtQuick.Controls 6.2
import net.alefbet 1.0

Window {
    width: 400
    height: 800

    visible: true

    //Ceci est une vue qui comporte plusieurs onglets
    //dont l'affichage est contrôlé par un glissement
    //latéral du doigt sur l'écran (swipe, ou balayage)
    SwipeView {
        id: swipeView
        anchors {
            top: tabBar.bottom
            right: parent.right
            bottom: parent.bottom
            left: parent.left
        }
        //On synchronise l'onglet affiché avec l'objet TabBar
        currentIndex: tabBar.currentIndex

        Chat {}
        Participants {}
    }

    //Nous créons un groupe d'onglet
    TabBar {
        id: tabBar
        anchors {
            left: parent.left
            right: parent.right
        }
        //On synchronise l'onglet activé avec l'objet Swipe
        currentIndex: swipeView.currentIndex

        TabButton {
            text: qsTr("Chat")
        }
        TabButton {
            text: qsTr("Participants")
        }
    }

    Component.onCompleted: {
        //on démarre le contrôleur réseau pour ouvrir
        //une session de chat et recevoir des messages
        ControleurReseau.demarre()
    }

}
