# Conteneurs

Cet exemple illustre le fonctionnement de certains conteneurs, notamment leur instanciation (automatique uniquement) et la façon dont ils sont optimisés pour éviter les copies de données en mémoire.

## Utilisation

Modifiez la valeur de la macro `TP` dans le fichier `main.cpp`. Les valeurs possibles vont de 1 à 5.

## Analyse

Le fichier Rectangle.h déclare une classe Point et une classe Rectangle.
La classe Rectangle a pour membre une instance de la classe `QList`, qui est un conteneur optimisé de Qt.

Nous allons observer au travers des différents TP l'impact des fonctions des conteneurs et des opérateurs *const*.

### TP n°1

Une instance de Rectangle est créée. L'adresse de la QList est affichée (proxy) ainsi que l'adresse des données de cette QList.

L'instance est ajoutée à une liste. 

L'instance est ensuite récupérée depuis la liste grâce à l'opérateur `[]`.

Nous constatons que l'adresse de la liste dans Rectangle a changé, mais pas l'adresse des données. C'est la preuve que le conteneur QList est optimisé et utilise la technique du pointeur partagé.

### TP n°2

L'opérateur `[]` est appelé avec un index inexistant. Cela provoque un crash de l'application.

### TP n°3

La fonction `QList::at()` est appelée avec un index inexistant. Cela provoque un crash de l'application.

### TP n°4

Une instance est insérée à un index inexistant, cela provoque un crash de l'application.

### TP n°5

Des instances de Rectangle sont créées et insérées puis récupérées dans une `QMap`. Notez l'utilisation de la fonction `QMap::key()` qui nécessite l'ajout d'une fonction `operator==` dans l'objet inséré.
