#ifndef RECTANGLE_H
#define RECTANGLE_H
#include <QList>
#include <QPoint>
#include <QRandomGenerator>

class Point {  
public:
    Point() {
        x = QRandomGenerator::global()->generate();
        y = QRandomGenerator::global()->generate();
        w = QRandomGenerator::global()->generate();
        h = QRandomGenerator::global()->generate();
    }
    int x = 0;
    int y = 0;
    int h = 0;
    int w = 0;
};

class Rectangle
{
public:
    Rectangle() {
        p << Point() << Point() << Point() << Point();
    }

    QString debug() const {
        QString debug;
        debug.append(QString("Adresse de l'instance : %1").arg((quintptr)&p, QT_POINTER_SIZE * 2, 16, QChar('0')));
        debug.append(QString("   Données @0x%1").arg((quintptr)p.constData(), QT_POINTER_SIZE * 2, 16, QChar('0')));
        return debug;
    }

    operator QString() const {
        return debug();
    }

    bool operator== (const Rectangle& orig) const {
        return (p.count() == orig.p.count())
                && p.count() == 4
                && p[0].x == orig.p[0].x
                && p[1].x == orig.p[1].x
                && p[2].x == orig.p[2].x
                && p[3].x == orig.p[3].x
                // etc
                ;
    }

private:
    QList<Point> p;
};

#endif // RECTANGLE_H
