# Signal Perso

Cet exemple met en évidence l'utilisation du méta-objet de Qt pour transporter dans des signaux des objets personnels issus de classes qui ne font pas partie des API de Qt.

## Utilisation

Modifiez la valeur de la macro `TP` dans le fichier `main.cpp`. Les valeurs possibles vont de 1 à 2.

## Analyse

Lorsqu'un signal est émis, en fonction de l'affinité de l'émetteur et du récepteur, l'appel du Slot est passé sur la run-loop et effectué directement, par branchement.

Si un signal passe par la run-loop, et s'il transporte des objets, ceux-ci doivent être compatibles avec le méta-objet de Qt. Ils doivent être des Types Qt.

Sous Qt 5, vous devez spécifier explicitement qu'un objet est un Type Qt en utilisant la fonction `qRegisterType<LaClasseDeL'Objet>("La syntaxe de l'appel")`. Par exemple si vous passez une instance de Rectangle par valeur, vous utiliserez `qRegisterType<Rectangle>("Rectangle")` mais si vous la passez par référence, vous utiliserez `qRegisterType<Rectangle>("Rectangle&")`. Vous pouvez faire les deux.

A vous de modifier le code de main.cpp pour que le programme compile. Sous Qt 6 vous n'avez rien à faire...

D'autre part, cette règle ne s'applique que si le signal est passé par la run-loop (connexion du type `QueuedConnection` ou affinité de thread différente). Alternez entre le TP 1 et le TP 2 en désactivant l'appel à `qRegisterType()` pour le constater.