# Signal-Slot

Cet exemple permet d'observer le comportement d'une application lorsque plusieurs connections sont effectuées entre deux objets, et qu'un signal est émis plusieurs fois.

## Utilisation

Modifiez la valeur de la macro `TP` dans le fichier `main.cpp`. Les valeurs possibles vont de 1 à 4.

## Analyse 

Les différents TP permettent d'observer différents phénomènes.

## TP n°1

Ajoutez le code nécessaire à la réception du signal et l'affichage du message "Signal reçu". 

Indices :

- il manque une connexion entre le signal et le Slot.

- la connexion se fait ainsi `QObject::connect(instanceEmettrice, adresseDuSignal, instanceReceptrice, adresseDuSlot);`.

- Rappelez-vous que l'instance émettrice et l'instance réceptrice sont des pointeurs. Il faudra peut-être déréférencer des variables.

- Pour obtenir l'adresse d'une fonction il faut utiliser la syntaxe `&Classe::fonction`, et négliger la signature de la fonction.

## TP n°2

Un même signal est connecté à un même Slot 4 fois. Si un seul signal est émis, le Slot sera appelé 4 fois, sauf si le drapeau `UniqueConnection` est ajouté au type de connexion.

## TP n°3 et 4

Un signal est connecté à un slot 2 fois, le signal est émis 2 fois. Le Slot sera donc appelé 4 fois en tout.

La différence entre le TP 3 et le 4 porte sur l'utilisation de la run-loop. Le résultat est le même dans les deux cas. Pourquoi ?

Réponse : car le type de connexion entre le Signal et le Slot est `AutoConnection`, cela signifie que la règle d'affinité de thread s'appliquer. En l'occurence, il n'y a qu'un seul thread, les deux objets ont donc la même affinité de thread, la connexion est donc en réalité du type `DirectConnection`. La run-loop n'est donc pas utilisée.