#include <QCoreApplication>
#include <QtEndian>
#include <QDebug>

int main(int, char **)
{
    qDebug() << "Conversion vers gros boutiste";

    quint32 a = 0x00112233;
    quint32 a2 = qToBigEndian(a);
    quint16 b = 0x00FF;
    quint16 b2 = qToBigEndian(b);

    qDebug() << "quint32 little endian (x86) = " << QString::number(a, 16);
    qDebug() << "quint32 big endian (x86) = " << QString::number(a2, 16);

    qDebug() << "quint16 little endian (x86) = " << QString::number(b, 16);
    qDebug() << "quint16 big endian (x86) = " << QString::number(b2, 16);

    qDebug() << "Conversion depuis gros boutiste";
    a = 0x33221100;
    a2 = qFromBigEndian(a);
    b = 0xff00;
    b2 = qFromBigEndian(b);

    qDebug() << "quint32 big endian (x86) = " << QString::number(a, 16);
    qDebug() << "quint32 little endian (x86) = " << QString::number(a2, 16);

    qDebug() << "quint16 big endian (x86) = " << QString::number(b, 16);
    qDebug() << "quint16 little endian (x86) = " << QString::number(b2, 16);

    return 0;
}
