#include <QCoreApplication>
#include <QDebug>
#include <QMetaType>
#include "Classe1.h"
#include "Classe2.h"

int main(int argc, char **argv)
{
    qRegisterMetaType<Classe1>("Classe1");
    qRegisterMetaType<Classe2>("Classe2");

    if(argc == 2) {
        QString nomDeLaClasse = QString::fromLatin1(argv[1]);
        qDebug() << "Nous allons essayer de créer une instance de la classe" << nomDeLaClasse;

#if QT_VERSION < 0x060000
        int id = QMetaType::type(nomDeLaClasse.toLatin1());  //Recherche de méta-type par le nom
        if(id != QMetaType::UnknownType) {     //Le Type est connu
            void *ptr = QMetaType::create(id);      //Création d’une nouvelle instance
            if(ptr != nullptr) {                                   //On peut utiliser la nouvelle instance ?
                qDebug() << "La classe est instanciée..." << ptr;
                QMetaType::destroy(id, ptr);
                ptr = nullptr;
            }
        } else {
            qDebug() << "La classe" << nomDeLaClasse << "n'existe pas";
        }
#else
        QMetaType type = QMetaType::fromName(nomDeLaClasse.toLatin1());
        if(type.isValid()) {
            void *ptr = type.create();

            qDebug() << "La classe est instanciée..." << ptr;

            type.destroy(ptr);
            ptr = nullptr;
        } else {
            qDebug() << "La classe" << nomDeLaClasse << "n'existe pas";
        }
#endif
    } else {
        qCritical() << "Il manque le nom de la classe à instancier";
    }
}
