#include <QCoreApplication>
#include <QFile>
#include <QTemporaryFile>
#include <QTextStream>
#include <QDebug>
#include <QDir>
#include <QFileInfo>

int main(int argc, char *argv[])
{
    QCoreApplication a(argc, argv);
    
    //On crée un fichier "test" dans le répertoire temporaire
    QFile f(QString("/%1/test").arg(QDir::tempPath()));
    //On affiche le chemin réel du fichier
    qDebug() << QFileInfo(f).absoluteFilePath();

    //On ouvre le fichier en lecture/écriture
    f.open(QIODevice::ReadWrite);

    //On crée un flux de texte pour écrire dans le fichier
    QTextStream st(&f);
    //Puis on écrit dans le flux de texte
    st << QString::fromUtf8("Une première ligne\n");
    st << QString::fromUtf8("Une deuxième ligne !\n");
    //On ferme le fichier
    f.close();

    //On rouvre le fichier en lecture seule
    f.open(QIODevice::ReadOnly);
    //On créer un autre flux de texte pour lire le contenu
    QTextStream st2(&f);
    //On lit le contenu du fichier ligne par ligne jusqu'à la fin
    while(!st2.atEnd())
    {
        QString l = st2.readLine();
        qDebug() << l;
    }

    //On ferme et on supprime le fichier
    f.close();
    f.remove();
}
