#include <QCoreApplication>
#include <QByteArray>
#include <QDataStream>
#include <QDebug>
#include <QRandomGenerator>
#include <QIODevice>

#include "MaClasse.h"
#include "Contexte.h"

int main(int argc, char *argv[])
{
    QCoreApplication a(argc, argv);    

    //Instanciation et initialisation d'un objet Contexte
    Contexte contexte;
    contexte.id = QRandomGenerator::global()->generate() % 0xFF;
    contexte.titre = "Mon contexte sérialisable";
    contexte.ok = true;

    //Instanciation et initialisation d'un objet MaClasse
    MaClasse classe;
    classe.id = QRandomGenerator::global()->generate() % 0xFF;
    classe.texte = "Ma classe sérialisable";
    classe.contexte = contexte;

    qDebug() << "L'id de classe est " << (int)classe.id;
    qDebug() << "L'id de contexte est " << (int)contexte.id;

    //Instanciation d'un tableau d'octets pour recevoir
    //le produit de la sérialisation
    QByteArray ba;
    //Instanciation d'un flux de données binaires pour écrire dans
    //le tableau d'octets
    QDataStream streamOut(&ba, QIODevice::WriteOnly);    
    streamOut << classe; //Sérialisation de l'instance de MaClasse

    //Instanciation d'un flux de données pour lire les données
    QDataStream streamIn(&ba, QIODevice::ReadOnly);
    MaClasse classe2;
    streamIn >> classe2; //Dé-sérialisation des données dans une instance de MaClasse

    //On vérifie que les variables membres ont été restaurées
    qDebug() << "Le nouvel id de classe est " << classe2.id;
    qDebug() << "Le nouvel id de contexte est " << classe2.contexte.id;
}
