# Threads

Cet exemple démontre l'utilisation des threads avec Qt.

## Utilisation

Changez la valeur de la déclaration `MAUVAISE_APPROCHE` dans le fichier Controleur.cpp pour observer différents comportements.

## Analyse

La destruction d'un thread fait planter une application si un travail est toujours en cours en son sein. Terminer et détruire un thread est une tâche délicate et il existe une façon d'architecturer son application pour le faire de manière totalement sûre, surtout dans un environnement d'exécution multi-plateformes.

Lorsque la déclaration `MAUVAISE_APPROCHE` est à 1, les threads sont détruits de façon non déterministe. L'hypothèse est faite qu'un délai de *n* millisecondes est suffisant pour laisser le temps au worker de terminer son travail et au thread de s'arrêter. Or, si ce délai est suffisant sur un PC puissant, il ne le sera sans doute pas sur une plateforme embarquée moins puissante. Quelle valeur choisir pour le délai dans ces conditions ?

Lorsque la déclaration `MAUVAISE_APPROCHE` est à 0, les threads sont détruits de façon déterministes, en utilisant l'inversion de contrôle et en enchainant les signaux de fin de travail, de destruction des classes et de terminaison des threads pour que tout se déroule dans le bon ordre.
