#include "Client.h"

Client::Client(QSharedPointer<SliderReplica> ptr, QObject* parent)
    : QObject(parent), reptr_(ptr)
{
    //A l'instanciation on initialise le client
    init();
}

void Client::init()
{
    //En cas de réception d'une nouvelle valeur on appelle le slot onValeurChanged
    connect(reptr_.data(), &SliderReplica::valeurChanged, this, &Client::onValeurChanged);
    //On accuse réception de la nouvelle valeur
    connect(this, &Client::echo, reptr_.data(), &SliderReplica::server_slot);
}

void Client::onValeurChanged(int valeur){
    //Lorsqu'une valeur est reçue, ce slot est appelé
    qDebug() << "Une valeur a été reçue par le client" << valeur << reptr_.data()->valeur();
    valeur_ = reptr_.data()->valeur();
    //On émet un signal pour que la valeur soit affichée
    emit echo(valeur_);
}
