#include "EcranServeur.h"
#include "ui_EcranServeur.h"
#include "Slider.h"

EcranServeur::EcranServeur(QWidget *parent)
    : QWidget(parent)
    , ui(new Ui::EcranServeur)
    , sliderSource_(new Slider(this))
#ifdef AVEC_REGISTRY
    , registryNode_(new QRemoteObjectRegistryHost(URL_REGISTRE, this))
#endif
    , srcNode_(new QRemoteObjectHost(
       URL_SOURCE
#ifdef AVEC_REGISTRY
       , URL_REGISTRE
       , QRemoteObjectHost::BuiltInSchemasOnly
#endif
       , this
   ))
{
    ui->setupUi(this);

    //On active la communication au travers de la source
    srcNode_->enableRemoting(sliderSource_);
}

EcranServeur::~EcranServeur()
{
    delete ui;
}


void EcranServeur::on_slider_valueChanged(int value)
{
    //Si l'utilisateur modifie la valeur, ce slot sera appelé
    qDebug() << "Valeur modifiée par l'utilisateur : " << value;
    ui->valeurHote->setText(QString::number(value));
    sliderSource_->setValeur(value);
}

