#include "MainWindow.h"
#include "ui_MainWindow.h"
#include <QMdiSubWindow>
#include <QVBoxLayout>
#include "SubWindow.h"

MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
    ui->setupUi(this);

    //La zone MDI prendra la place du
    //widget central par défaut
    setCentralWidget(ui->mdiArea);

    //On instancie un premier widget de base
    SubWindow* sub = new SubWindow(this) ;

    //On crée une sous-fenêtre dans la zone MDI
    //En utilisant notre widget
    ui->mdiArea->addSubWindow(sub) ;

    //Instancions directement une sous-fenêtre
    QMdiSubWindow* mdi = new QMdiSubWindow(this) ;

    //Définissons un layout
    mdi->setLayout(new QVBoxLayout(this)) ;

    //Instancions notre widget
    SubWindow* sub2 = new SubWindow(this) ;

    //Ajoutons notre widget à la fenêtre
    mdi->layout()->addWidget(sub2) ;

    //Enfin ajoutons la fenêtre à la zone MDI
    ui->mdiArea->addSubWindow(mdi) ;
}

MainWindow::~MainWindow()
{
    delete ui;
}
