#include "MainWindow.h"
#include "ui_MainWindow.h"
#include <QMenu>
#include <QAction>
#include <QCoreApplication>
#include <QDebug>

MainWindow::MainWindow(QWidget *parent)
    : QMainWindow(parent)
    , ui(new Ui::MainWindow)
{
    ui->setupUi(this);
    creeMenuContextuel();
}

MainWindow::~MainWindow()
{
    delete ui;
}

void MainWindow::creeMenuContextuel()
{
    //Créer un menu contextuel
    QAction *actionTerminer = new QAction(tr("Terminer"), this);
    actionTerminer->setShortcut(QKeySequence(Qt::CTRL | Qt::Key_T));
    connect(actionTerminer, &QAction::triggered, [] { //Connexion utilisant une fonction lambda
        qApp->quit();
    });
    menuFichiers_ = new QMenu(tr("Fichiers"), this);
    menuFichiers_->addAction(actionTerminer);
    ui->menubar->addMenu(menuFichiers_);

    //syntaxe signal-slot
    // connect( émetteur*, SIGNAL(nomdusignal), récepteur*, SLOT(nomduslot) );
    // connect( émetteur*, &Classe::signal, récepteur*, &Classe::slot );

    //émetteur : ui->centralWidget
    //signal: customContextMenuRequest(const QPoint&)
    //SLOT : fonction lambda dans laquelle on affiche le menu -> menuFichiers_->show()
    connect(ui->centralwidget, &QWidget::customContextMenuRequested, this, &MainWindow::onMenuContextuel);
}

//Afficher le menu à l'emplacement du pointeur de la souris
//Le clic droit de la souris est capté grâce à un slot connecté
//au signal void customContextMenuRequest(const QPoint&)




void MainWindow::on_actionCopier_triggered()
{
    qDebug("Copier quelque chose");
}

void MainWindow::on_actionColler_triggered()
{

}

void MainWindow::onMenuContextuel(const QPoint &pos)
{
    menuFichiers_->show();
    menuFichiers_->move(ui->centralwidget->mapToGlobal(pos));
    qDebug() << "Coordonnées reçues : " << pos;
    qDebug() << "Coordonnées relocalisées : " << ui->centralwidget->mapToGlobal(pos);
}

