#ifndef OBJETSUPER_H
#define OBJETSUPER_H

#include <QString>
#include <QSharedPointer>
#include <QSharedData>
#include <QDebug>

class ObjetSuperData : public QSharedData {
public:
    ObjetSuperData() {}

    //Fonctions de debug permettant de vérifier si l'objet est copié
    //Si tout va bien on devrait constater que l'objet n'est jamais copié...
    ObjetSuperData(const ObjetSuperData& orig) : id(orig.id), nom(orig.nom) {
        qDebug() << "Le constructeur de copie de ObjetSuperData a été appelé";
    }
    ObjetSuperData& operator=(const ObjetSuperData& orig) {
        qDebug() << "L'opérateur de copie de ObjetSuperData a été appelé";

        id = orig.id;
        nom = orig.nom;

        return *this;
    }

    int id = 0;
    QString nom;
};

class ObjetSuper
{
public:
    ObjetSuper();    
    ObjetSuper(const ObjetSuper &);

    int id() const { return d_->id; }
    void setId(const int& id) { d_->id = id; }
    QString nom() const { return d_->nom; }
    void setNom(const QString& nom) { d_->nom = nom; }

private:
    QSharedPointer<ObjetSuperData> d_;
};

#endif // OBJETSUPER_H
