#include "TableModel.h"
#include "FakeDAO.h"

TableModel::TableModel(QObject *parent)
    : QAbstractItemModel{parent}
{
    //Mise à jour de la mémoire tampon
    tampon_ = FakeDAO::getNoms();
}

void TableModel::fetchMore(const QModelIndex &)
{
    //Mise à jour de la mémoire tampon
    tampon_ = FakeDAO::getNoms();
}

bool TableModel::canFetchMore(const QModelIndex &) const
{
    //On renvoie true tout le temps car on ne gère pas le
    //lazy loading
    return true;
}

QModelIndex TableModel::index(int row, int column, const QModelIndex &) const
{
    //Fonctionnement standard
    return createIndex(row, column);
}

QModelIndex TableModel::parent(const QModelIndex &) const
{
    //Pour un tableau, pas de parent
    return QModelIndex();
}

int TableModel::rowCount(const QModelIndex &) const
{
    return tampon_.size();
}

int TableModel::columnCount(const QModelIndex &) const
{
    return 2; //Id et nom
}

QVariant TableModel::data(const QModelIndex &index, int role) const
{
    qDebug() << role;
    if(tampon_.size() < index.row()) {
        return QVariant();
    }

    switch(role) {
    case Qt::DisplayRole: return getValeur(index);
    case Qt::ToolTipRole: return "Information";
    }

    return QVariant();
}

QVariant TableModel::getValeur(const QModelIndex &index) const
{
    if(index.column() == 0) {
        ObjetSuper obj = tampon_[index.row()];
        return tampon_[index.row()].id();
    } else {
        return tampon_[index.row()].nom();
    }

}

